org.bdgenomics.adam.rdd.read

# AlignmentRecordDataset

###
Related Docs: object AlignmentRecordDataset | package read

#### sealed abstract class AlignmentRecordDataset extends AvroReadGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

Linear Supertypes
AvroReadGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset], GenomicDatasetWithLineage[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset], AvroGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset], GenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset], Logging, AnyRef, Any
Known Subclasses
DatasetBoundAlignmentRecordDataset, ParquetUnboundAlignmentRecordDataset, RDDBoundAlignmentRecordDataset
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. AlignmentRecordDataset
2. AvroReadGroupGenomicDataset
3. GenomicDatasetWithLineage
4. AvroGenomicDataset
5. GenomicDataset
6. Logging
7. AnyRef
8. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract val dataset: Dataset[AlignmentRecord]

   These data as a Spark SQL Dataset.

   These data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset

2. #### abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

   Attributes
     protected
   Definition Classes
     GenomicDataset

3. #### abstract val processingSteps: Seq[ProcessingStep]

   The processing steps that have been applied to this GenomicDataset.

   The processing steps that have been applied to this GenomicDataset.

   Definition Classes
     GenomicDatasetWithLineage

4. #### abstract val rdd: RDD[AlignmentRecord]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicDataset

5. #### abstract val readGroups: ReadGroupDictionary

   A dictionary describing the read groups attached to this GenomicDataset.

   A dictionary describing the read groups attached to this GenomicDataset.

   Definition Classes
     AvroReadGroupGenomicDataset

6. #### abstract def replaceProcessingSteps(newProcessingSteps: Seq[ProcessingStep]): AlignmentRecordDataset

   Replaces the processing steps attached to this genomic dataset.

   Replaces the processing steps attached to this genomic dataset.

   newProcessingSteps

     The new processing steps to attach to this genomic dataset.

   returns

     Returns a new GenomicDataset with new processing lineage attached.

   Definition Classes
     GenomicDatasetWithLineage

7. #### abstract def replaceReadGroups(newReadGroups: ReadGroupDictionary): AlignmentRecordDataset

   Replaces the read groups attached to this genomic dataset.

   Replaces the read groups attached to this genomic dataset.

   newReadGroups

     The new read group dictionary to attach.

   returns

     Returns a new GenomicDataset with new read groups attached.

   Definition Classes
     AvroReadGroupGenomicDataset

8. #### abstract def replaceSequences(newSequences: SequenceDictionary): AlignmentRecordDataset

   Replaces the sequence dictionary attached to a GenomicDataset.

   Replaces the sequence dictionary attached to a GenomicDataset.

   newSequences

     The new sequence dictionary to attach.

   returns

     Returns a new GenomicDataset with the sequences replaced.

   Definition Classes
     GenomicDataset

9. #### abstract val sequences: SequenceDictionary

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   Definition Classes
     GenomicDataset

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def addProcessingStep(newProcessingStep: ProcessingStep): AlignmentRecordDataset

   Merges a new processing record with the extant computational lineage.

   Merges a new processing record with the extant computational lineage.

   returns

     Returns a new GenomicDataset with new read groups merged in.

   Definition Classes
     GenomicDatasetWithLineage

5. #### def addReadGroup(readGroupToAdd: ReadGroup): AlignmentRecordDataset

   Adds a single read group to the extant read groups.

   Adds a single read group to the extant read groups.

   readGroupToAdd

     The read group to append to the extant read groups.

   returns

     Returns a new GenomicDataset with the new read group added.

   Definition Classes
     AvroReadGroupGenomicDataset

6. #### def addReadGroups(readGroupsToAdd: ReadGroupDictionary): AlignmentRecordDataset

   Merges a new set of read groups with the extant read groups.

   Merges a new set of read groups with the extant read groups.

   readGroupsToAdd

     The read group dictionary to append to the extant read groups.

   returns

     Returns a new GenomicDataset with new read groups merged in.

   Definition Classes
     AvroReadGroupGenomicDataset

7. #### def addSequence(sequenceToAdd: SequenceRecord): AlignmentRecordDataset

   Appends metadata for a single sequence to the current genomic dataset.

   Appends metadata for a single sequence to the current genomic dataset.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicDataset with this sequence appended.

   Definition Classes
     GenomicDataset

8. #### def addSequences(sequencesToAdd: SequenceDictionary): AlignmentRecordDataset

   Appends sequence metadata to the current genomic dataset.

   Appends sequence metadata to the current genomic dataset.

   sequencesToAdd

     The new sequences to append.

   returns

     Returns a new GenomicDataset with the sequences appended.

   Definition Classes
     GenomicDataset

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def binQualityScores(bins: Seq[QualityScoreBin]): AlignmentRecordDataset

    (Scala-specific) Rewrites the quality scores of reads to place all quality scores in bins.

    (Scala-specific) Rewrites the quality scores of reads to place all quality scores in bins.

    Quality score binning maps all quality scores to a limited number of discrete values, thus reducing the entropy of the quality score distribution, and reducing the amount of space that reads consume on disk.

    bins

      The bins to use.

    returns

      Reads whose quality scores are binned.

11. #### def binQualityScores(bins: List[QualityScoreBin]): AlignmentRecordDataset

    (Java-specific) Rewrites the quality scores of reads to place all quality scores in bins.

    (Java-specific) Rewrites the quality scores of reads to place all quality scores in bins.

    Quality score binning maps all quality scores to a limited number of discrete values, thus reducing the entropy of the quality score distribution, and reducing the amount of space that reads consume on disk.

    bins

      The bins to use.

    returns

      Reads whose quality scores are binned.

12. #### def broadcast()(implicit tTag: ClassTag[AlignmentRecord]): GenomicBroadcast[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

    Definition Classes
      GenomicDataset

13. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

14. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

15. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

16. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

17. #### def broadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Y, AlignmentRecord)]): GenericGenomicDataset[(X, AlignmentRecord), (Y, AlignmentRecord)]

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

18. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], AlignmentRecord)]): GenericGenomicDataset[(Iterable[X], AlignmentRecord), (Seq[Y], AlignmentRecord)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

19. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

20. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

21. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

22. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

23. #### def buildTree(rdd: RDD[(ReferenceRegion, AlignmentRecord)])(implicit tTag: ClassTag[AlignmentRecord]): IntervalArray[ReferenceRegion, AlignmentRecord]

    Attributes
      protected
    Definition Classes
      AlignmentRecordDataset → GenomicDataset

24. #### def cache(): AlignmentRecordDataset

    Caches underlying RDD in memory.

    Caches underlying RDD in memory.

    returns

      Cached GenomicDataset.

    Definition Classes
      GenomicDataset

25. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### def computeMismatchingPositions(referenceFile: ReferenceFile, overwriteExistingTags: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordDataset

    (Scala-specific) Computes the mismatching positions field (SAM "MD" tag).

    (Scala-specific) Computes the mismatching positions field (SAM "MD" tag).

    referenceFile

      A reference file that can be broadcast to all nodes.

    overwriteExistingTags

      If true, overwrites the MD tags on reads where it is already populated. If false, we only tag reads that are currently missing an MD tag. Default is false.

    validationStringency

      If we are recalculating existing tags and we find that the MD tag that was previously on the read doesn't match our new tag, LENIENT will log a warning message, STRICT will throw an exception, and SILENT will ignore. Default is LENIENT.

    returns

      Returns a new AlignmentRecordDataset where all reads have the mismatchingPositions field populated.

27. #### def computeMismatchingPositions(referenceFile: ReferenceFile, overwriteExistingTags: Boolean, validationStringency: ValidationStringency): AlignmentRecordDataset

    (Java-specific) Computes the mismatching positions field (SAM "MD" tag).

    (Java-specific) Computes the mismatching positions field (SAM "MD" tag).

    referenceFile

      A reference file that can be broadcast to all nodes.

    overwriteExistingTags

      If true, overwrites the MD tags on reads where it is already populated. If false, we only tag reads that are currently missing an MD tag.

    validationStringency

      If we are recalculating existing tags and we find that the MD tag that was previously on the read doesn't match our new tag, LENIENT will log a warning message, STRICT will throw an exception, and SILENT will ignore.

    returns

      Returns a new AlignmentRecordDataset where all reads have the mismatchingPositions field populated.

28. #### def convertToSam(sortOrder: SortOrder): (RDD[SAMRecordWritable], SAMFileHeader)

29. #### def convertToSam(isSorted: Boolean = false): (RDD[SAMRecordWritable], SAMFileHeader)

    Converts an RDD of ADAM read records into SAM records.

    Converts an RDD of ADAM read records into SAM records.

    returns

      Returns a SAM/BAM formatted RDD of reads, as well as the file header.

30. #### def countKmers(kmerLength: Int): RDD[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns an RDD containing k-mer/count pairs.

31. #### def countKmersAsDataset(kmerLength: Int): Dataset[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns a Dataset containing k-mer/count pairs.

32. #### def debug(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

33. #### def debug(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

34. #### def debug(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

35. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

36. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

37. #### def error(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

38. #### def error(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

39. #### def error(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

40. #### def filterByMappingQuality(minimumMappingQuality: Int): AlignmentRecordDataset

    Filter this AlignmentRecordDataset by mapping quality.

    Filter this AlignmentRecordDataset by mapping quality.

    minimumMappingQuality

      Minimum mapping quality to filter by, inclusive.

    returns

      AlignmentRecordDataset filtered by mapping quality.

41. #### def filterByOverlappingRegion(query: ReferenceRegion): AlignmentRecordDataset

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the query region.

    Definition Classes
      GenomicDataset

42. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): AlignmentRecordDataset

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

43. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): AlignmentRecordDataset

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

44. #### def filterDuplicateReads(): AlignmentRecordDataset

    Filter duplicate reads from this AlignmentRecordDataset.

    Filter duplicate reads from this AlignmentRecordDataset.

    returns

      AlignmentRecordDataset filtered to remove duplicate reads.

45. #### def filterToPrimaryAlignments(): AlignmentRecordDataset

    Filter this AlignmentRecordDataset to include only primary alignments.

    Filter this AlignmentRecordDataset to include only primary alignments.

    returns

      AlignmentRecordDataset filtered to include only primary alignments.

46. #### def filterToReadGroup(readGroupId: String): AlignmentRecordDataset

    Filter this AlignmentRecordDataset by read group to those that match the specified read group.

    Filter this AlignmentRecordDataset by read group to those that match the specified read group.

    readGroupId

      Read group to filter by.

    returns

      AlignmentRecordDataset filtered by read group.

47. #### def filterToReadGroups(readGroupIds: Seq[String]): AlignmentRecordDataset

    (Scala-specific) Filter this AlignmentRecordDataset by read group to those that match the specified read groups.

    (Scala-specific) Filter this AlignmentRecordDataset by read group to those that match the specified read groups.

    readGroupIds

      Sequence of read groups to filter by.

    returns

      AlignmentRecordDataset filtered by one or more read groups.

48. #### def filterToReadGroups(readGroupIds: List[String]): AlignmentRecordDataset

    (Java-specific) Filter this AlignmentRecordDataset by read group to those that match the specified read groups.

    (Java-specific) Filter this AlignmentRecordDataset by read group to those that match the specified read groups.

    readGroupIds

      List of read groups to filter by.

    returns

      AlignmentRecordDataset filtered by one or more read groups.

49. #### def filterToSample(readGroupSampleId: String): AlignmentRecordDataset

    Filter this AlignmentRecordDataset by sample to those that match the specified sample.

    Filter this AlignmentRecordDataset by sample to those that match the specified sample.

    readGroupSampleId

      Sample to filter by.

    returns

      AlignmentRecordDataset filtered by the specified sample.

50. #### def filterToSamples(readGroupSampleIds: Seq[String]): AlignmentRecordDataset

    (Scala-specific) Filter this AlignmentRecordDataset by sample to those that match the specified samples.

    (Scala-specific) Filter this AlignmentRecordDataset by sample to those that match the specified samples.

    readGroupSampleIds

      Sequence of samples to filter by.

    returns

      AlignmentRecordDataset filtered by the specified samples.

51. #### def filterToSamples(readGroupSampleIds: List[String]): AlignmentRecordDataset

    (Java-specific) Filter this AlignmentRecordDataset by sample to those that match the specified samples.

    (Java-specific) Filter this AlignmentRecordDataset by sample to those that match the specified samples.

    readGroupSampleIds

      List of samples to filter by.

    returns

      AlignmentRecordDataset filtered by the specified samples.

52. #### def filterUnalignedReads(): AlignmentRecordDataset

    Filter unaligned reads from this AlignmentRecordDataset.

    Filter unaligned reads from this AlignmentRecordDataset.

    returns

      AlignmentRecordDataset filtered to remove unaligned reads.

53. #### def filterUnpairedReads(): AlignmentRecordDataset

    Filter unpaired reads from this AlignmentRecordDataset.

    Filter unpaired reads from this AlignmentRecordDataset.

    returns

      AlignmentRecordDataset filtered to remove unpaired reads.

54. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

55. #### def flagStat(): (FlagStatMetrics, FlagStatMetrics)

    Runs a quality control pass akin to the Samtools FlagStat tool.

    Runs a quality control pass akin to the Samtools FlagStat tool.

    returns

      Returns a tuple of (failedQualityMetrics, passedQualityMetrics)

56. #### def flattenRddByRegions(): RDD[(ReferenceRegion, AlignmentRecord)]

    Attributes
      protected
    Definition Classes
      GenomicDataset

57. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otoxTag: ClassTag[(Option[AlignmentRecord], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Option[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

58. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otoxTag: ClassTag[(Option[AlignmentRecord], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Option[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

59. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

60. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], Option[X]), (Option[AlignmentRecord], Option[Y])]

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

61. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

62. #### def getReferenceRegions(elem: AlignmentRecord): Seq[ReferenceRegion]

    Returns all reference regions that overlap this read.

    Returns all reference regions that overlap this read.

    If a read is unaligned, it covers no reference region. If a read is aligned we expect it to cover a single region. A chimeric read would cover multiple regions, but we store chimeric reads in a way similar to BAM, where the split alignments are stored in multiple separate reads.

    elem

      Read to produce regions for.

    returns

      The seq of reference regions this read covers.

    Attributes
      protected
    Definition Classes
      AlignmentRecordDataset → GenomicDataset

63. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

64. #### def info(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

65. #### def info(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

66. #### def info(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

67. #### def isDebugEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

68. #### def isErrorEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

69. #### def isInfoEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

70. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

71. #### def isSorted: Boolean

    Definition Classes
      GenomicDataset

72. #### def isTraceEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

73. #### def isWarnEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

74. #### lazy val jrdd: JavaRDD[AlignmentRecord]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicDataset

75. #### def leftNormalizeIndels(): AlignmentRecordDataset

    Left normalizes the INDELs in reads containing INDELs.

    Left normalizes the INDELs in reads containing INDELs.

    returns

      Returns a new genomic dataset where the reads that contained INDELs have their INDELs left normalized.

76. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Option[Y])]): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

77. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Option[Y])]): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

78. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

79. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Option[X]), (AlignmentRecord, Option[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

80. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

81. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], toxTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

82. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

83. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

84. #### def logger: Logger

    Attributes
      protected
    Definition Classes
      Logging

85. #### def loggerName: String

    Attributes
      protected
    Definition Classes
      Logging

86. #### def markDuplicates(): AlignmentRecordDataset

    Marks reads as possible fragment duplicates.

    Marks reads as possible fragment duplicates.

    returns

      A new genomic dataset where reads have the duplicate read flag set. Duplicate reads are NOT filtered out.

87. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

88. #### final def notify(): Unit

    Definition Classes
      AnyRef

89. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

90. #### def persist(sl: StorageLevel): AlignmentRecordDataset

    Persists underlying RDD in memory or disk.

    Persists underlying RDD in memory or disk.

    sl

      new StorageLevel

    returns

      Persisted GenomicDataset.

    Definition Classes
      GenomicDataset

91. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, W]](cmd: List[String], files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[AlignmentRecordDataset, RDD[X], Z]): Z

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

92. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, W]](cmd: Seq[Any], files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[AlignmentRecordDataset, RDD[X], Z]): Z

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

93. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, W]](cmd: Seq[String], files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0, optTimeout: Option[Int] = None)(implicit tFormatterCompanion: InFormatterCompanion[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, W], xFormatter: OutFormatter[X], convFn: (AlignmentRecordDataset, RDD[X]) ⇒ Z, tManifest: ClassTag[AlignmentRecord], xManifest: ClassTag[X]): Z

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicDataset. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    optTimeout

      An optional parameter specifying how long to let a single partition run for, in seconds. If the partition times out, the partial results will be returned, and no exception will be logged. The partition will log that the command timed out.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

94. #### val productFn: (AlignmentRecord) ⇒ AlignmentRecord

    Attributes
      protected
    Definition Classes
      AlignmentRecordDataset → GenomicDataset

95. #### def realignIndels(consensusModel: ConsensusGenerator = new ConsensusGeneratorFromReads, isSorted: Boolean = false, maxIndelSize: Int = 500, maxConsensusNumber: Int = 30, lodThreshold: Double = 5.0, maxTargetSize: Int = 3000, maxReadsPerTarget: Int = 20000, unclipReads: Boolean = false, optReferenceFile: Option[ReferenceFile] = None): AlignmentRecordDataset

    (Scala-specific) Realigns indels using a consensus-based heuristic.

    (Scala-specific) Realigns indels using a consensus-based heuristic.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort. Defaults to false.

    maxIndelSize

      The size of the largest indel to use for realignment. Defaults to 500.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region. Defaults to 30.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded. Defaults to 5.0.

    maxTargetSize

      The maximum width of a single target region for realignment. Defaults to 3000.

    maxReadsPerTarget

      Maximum number of reads per target. Defaults to 20000.

    unclipReads

      If true, unclips reads prior to realignment. Else, omits clipped bases during realignment. Defaults to false.

    optReferenceFile

      An optional reference. If not provided, reference will be inferred from MD tags. Defaults to None.

    returns

      Returns a genomic dataset of mapped reads which have been realigned.

96. #### def realignIndels(consensusModel: ConsensusGenerator, isSorted: Boolean, maxIndelSize: Integer, maxConsensusNumber: Integer, lodThreshold: Double, maxTargetSize: Integer, maxReadsPerTarget: Integer, unclipReads: Boolean, referenceFile: ReferenceFile): AlignmentRecordDataset

    (Java-specific) Realigns indels using a consensus-based heuristic with the specified reference.

    (Java-specific) Realigns indels using a consensus-based heuristic with the specified reference.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort.

    maxIndelSize

      The size of the largest indel to use for realignment.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded.

    maxTargetSize

      The maximum width of a single target region for realignment.

    maxReadsPerTarget

      Maximum number of reads per target.

    unclipReads

      If true, unclips reads prior to realignment. Else, omits clipped bases during realignment.

    referenceFile

      Reference file.

    returns

      Returns a genomic dataset of mapped reads which have been realigned.

97. #### def realignIndels(consensusModel: ConsensusGenerator, isSorted: Boolean, maxIndelSize: Integer, maxConsensusNumber: Integer, lodThreshold: Double, maxTargetSize: Integer, maxReadsPerTarget: Integer, unclipReads: Boolean): AlignmentRecordDataset

    (Java-specific) Realigns indels using a consensus-based heuristic.

    (Java-specific) Realigns indels using a consensus-based heuristic.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort.

    maxIndelSize

      The size of the largest indel to use for realignment.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded.

    maxTargetSize

      The maximum width of a single target region for realignment.

    maxReadsPerTarget

      Maximum number of reads per target.

    unclipReads

      If true, unclips reads prior to realignment. Else, omits clipped bases during realignment.

    returns

      Returns a genomic dataset of mapped reads which have been realigned.

98. #### def realignIndels(referenceFile: ReferenceFile): AlignmentRecordDataset

    (Java-specific) Realigns indels using a consensus-based heuristic with the specified reference and default parameters.

    (Java-specific) Realigns indels using a consensus-based heuristic with the specified reference and default parameters.

    referenceFile

      Reference file.

    returns

      Returns a genomic dataset of mapped reads which have been realigned.

99. #### def realignIndels(): AlignmentRecordDataset

    (Java-specific) Realigns indels using a consensus-based heuristic with default parameters.

    (Java-specific) Realigns indels using a consensus-based heuristic with default parameters.

    returns

      Returns a genomic dataset of mapped reads which have been realigned.

100. #### def reassembleReadPairs(secondPairRdd: RDD[AlignmentRecord], validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordDataset

     (Scala-specific) Reassembles read pairs from two sets of unpaired reads.

     (Scala-specific) Reassembles read pairs from two sets of unpaired reads. The assumption is that the two sets were _originally_ paired together.

     secondPairRdd

       The rdd containing the second read from the pairs.

     validationStringency

       How stringently to validate the reads.

     returns

       Returns a genomic dataset with the pair information recomputed.

     Note

       The RDD that this is called on should be the RDD with the first read from the pair.

101. #### def reassembleReadPairs(secondPairRdd: JavaRDD[AlignmentRecord], validationStringency: ValidationStringency): AlignmentRecordDataset

     (Java-specific) Reassembles read pairs from two sets of unpaired reads.

     (Java-specific) Reassembles read pairs from two sets of unpaired reads. The assumption is that the two sets were _originally_ paired together.

     secondPairRdd

       The rdd containing the second read from the pairs.

     validationStringency

       How stringently to validate the reads.

     returns

       Returns a genomic dataset with the pair information recomputed.

     Note

       The RDD that this is called on should be the RDD with the first read from the pair.

102. #### def recalibrateBaseQualities(knownSnps: Broadcast[SnpTable], minAcceptableQuality: Int = 5, optStorageLevel: Option[StorageLevel] = Some(StorageLevel.MEMORY_ONLY), optSamplingFraction: Option[Double] = None, optSamplingSeed: Option[Long] = None): AlignmentRecordDataset

     (Scala-specific) Runs base quality score recalibration on a set of reads.

     (Scala-specific) Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

     knownSnps

       A table of known SNPs to mask valid variants.

     minAcceptableQuality

       The minimum quality score to recalibrate.

     optStorageLevel

       An optional storage level to set for the output of the first stage of BQSR. Defaults to StorageLevel.MEMORY_ONLY.

     optSamplingFraction

       An optional fraction of reads to sample when generating the covariate table.

     optSamplingSeed

       An optional seed to provide if downsampling reads.

     returns

       Returns a genomic dataset of recalibrated reads.

103. #### def recalibrateBaseQualities(knownSnps: VariantDataset, minAcceptableQuality: Integer, storageLevel: StorageLevel, samplingFraction: Double, samplingSeed: Long): AlignmentRecordDataset

     (Java-specific) Runs base quality score recalibration on a set of reads.

     (Java-specific) Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

     knownSnps

       A table of known SNPs to mask valid variants.

     minAcceptableQuality

       The minimum quality score to recalibrate.

     storageLevel

       Storage level to set for the output of the first stage of BQSR. Set to null to omit.

     samplingFraction

       Fraction of reads to sample when generating the covariate table.

     samplingSeed

       Seed to provide if downsampling reads.

     returns

       Returns a genomic dataset of recalibrated reads.

104. #### def recalibrateBaseQualities(knownSnps: VariantDataset, minAcceptableQuality: Integer, storageLevel: StorageLevel): AlignmentRecordDataset

     (Java-specific) Runs base quality score recalibration on a set of reads.

     (Java-specific) Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

     knownSnps

       A table of known SNPs to mask valid variants.

     minAcceptableQuality

       The minimum quality score to recalibrate.

     storageLevel

       An optional storage level to set for the output of the first stage of BQSR. Set to null to omit.

     returns

       Returns a genomic dataset of recalibrated reads.

105. #### def replaceRdd(newRdd: RDD[AlignmentRecord], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): AlignmentRecordDataset

     Attributes
       protected
     Definition Classes
       AlignmentRecordDataset → GenomicDataset

106. #### def replaceRddAndSequences(newRdd: RDD[AlignmentRecord], newSequences: SequenceDictionary, partitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): AlignmentRecordDataset

     Replaces the underlying RDD and SequenceDictionary and emits a new object.

     Replaces the underlying RDD and SequenceDictionary and emits a new object.

     newRdd

       New RDD to replace current RDD.

     newSequences

       New sequence dictionary to replace current dictionary.

     returns

       Returns a new AlignmentRecordDataset.

     Attributes
       protected

107. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoin

108. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoin

109. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

110. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

111. #### def rightOuterBroadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], oyuTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Y], AlignmentRecord)]): GenericGenomicDataset[(Option[X], AlignmentRecord), (Option[Y], AlignmentRecord)]

     Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

     Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

     broadcast

       The data on the left side of the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset
     Note

       This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

     See also

       rightOuterBroadcastRegionJoin

112. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], AlignmentRecord)]): GenericGenomicDataset[(Iterable[X], AlignmentRecord), (Seq[Y], AlignmentRecord)]

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

     broadcast

       The data on the left side of the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset
     Note

       This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

     See also

       rightOuterBroadcastRegionJoinAndGroupByRight

113. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

114. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[AlignmentRecord], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[AlignmentRecord], Y)]): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

115. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

116. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[AlignmentRecord], X), (Seq[AlignmentRecord], Y)]

     (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

     In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset
     See also

       rightOuterBroadcastRegionJoinAgainstAndGroupByRight

117. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

118. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otxTag: ClassTag[(Option[AlignmentRecord], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Y)]): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

119. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

120. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], X), (Option[AlignmentRecord], Y)]

     (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

     Definition Classes
       GenomicDataset

121. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otixTag: ClassTag[(Option[AlignmentRecord], Iterable[X])], otsyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Seq[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

     Definition Classes
       GenomicDataset

122. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], otixTag: ClassTag[(Option[AlignmentRecord], Iterable[X])], ousyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[AlignmentRecord], Seq[Y])]): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

     Definition Classes
       GenomicDataset

123. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

     Definition Classes
       GenomicDataset

124. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[AlignmentRecord], Iterable[X]), (Option[AlignmentRecord], Seq[Y])]

     (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

     Definition Classes
       GenomicDataset

125. #### def save(filePath: String, isSorted: Boolean): Boolean

     Saves this genomic dataset to disk, with the type identified by the extension.

     Saves this genomic dataset to disk, with the type identified by the extension.

     filePath

       Path to save the file at.

     isSorted

       Whether the file is sorted or not.

     returns

       Returns true if saving succeeded.

126. #### def save(args: ADAMSaveAnyArgs, isSorted: Boolean = false): Boolean

     Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

     Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

     This method infers the output format from the file extension. Filenames ending in .sam/.bam are saved as SAM/BAM, and all other files are saved as Parquet.

     args

       Save configuration arguments.

     isSorted

       If the output is sorted, this will modify the SAM/BAM header.

     returns

       Returns true if saving succeeded.

127. #### def saveAsFastq(fileName: String, fileName2Opt: Option[String] = None, outputOriginalBaseQualities: Boolean = false, sort: Boolean = false, asSingleFile: Boolean = false, disableFastConcat: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

     Saves reads in FASTQ format.

     Saves reads in FASTQ format.

     fileName

       Path to save files at.

     fileName2Opt

       Optional second path for saving files. If set, two files will be saved.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     sort

       Whether to sort the FASTQ files by read name or not. Defaults to false. Sorting the output will recover pair order, if desired.

     asSingleFile

       By default (false), writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this genomic dataset is not accompanied by its mate.

     persistLevel

       An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

128. #### def saveAsFastq(fileName: String, outputOriginalBaseQualities: Boolean, sort: Boolean, asSingleFile: Boolean, disableFastConcat: Boolean, validationStringency: ValidationStringency): Unit

     (Java-specific) Saves reads in FASTQ format.

     (Java-specific) Saves reads in FASTQ format.

     fileName

       Path to save files at.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     sort

       Whether to sort the FASTQ files by read name or not. Defaults to false. Sorting the output will recover pair order, if desired.

     asSingleFile

       If false, writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this genomic dataset is not accompanied by its mate.

129. #### def saveAsPairedFastq(fileName1: String, fileName2: String, outputOriginalBaseQualities: Boolean = false, asSingleFile: Boolean = false, disableFastConcat: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

     Saves these AlignmentRecords to two FASTQ files.

     Saves these AlignmentRecords to two FASTQ files.

     The files are one for the first mate in each pair, and the other for the second mate in the pair.

     fileName1

       Path at which to save a FASTQ file containing the first mate of each pair.

     fileName2

       Path at which to save a FASTQ file containing the second mate of each pair.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     asSingleFile

       By default (false), writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this genomic dataset is not accompanied by its mate.

     persistLevel

       An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

130. #### def saveAsPairedFastq(fileName1: String, fileName2: String, outputOriginalBaseQualities: Boolean, asSingleFile: Boolean, disableFastConcat: Boolean, validationStringency: ValidationStringency, persistLevel: StorageLevel): Unit

     (Java-specific) Saves these AlignmentRecords to two FASTQ files.

     (Java-specific) Saves these AlignmentRecords to two FASTQ files.

     The files are one for the first mate in each pair, and the other for the second mate in the pair.

     fileName1

       Path at which to save a FASTQ file containing the first mate of each pair.

     fileName2

       Path at which to save a FASTQ file containing the second mate of each pair.

     outputOriginalBaseQualities

       If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

     asSingleFile

       If false, writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     validationStringency

       Iff strict, throw an exception if any read in this genomic dataset is not accompanied by its mate.

     persistLevel

       The persistence level to cache reads at between passes.

131. #### def saveAsParquet(pathName: String): Unit

     Saves this genomic dataset to disk as a Parquet file.

     Saves this genomic dataset to disk as a Parquet file.

     pathName

       Path to save the file at.

     Definition Classes
       AvroGenomicDataset

132. #### def saveAsParquet(pathName: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

     (Java-specific) Saves this genomic dataset to disk as a Parquet file.

     (Java-specific) Saves this genomic dataset to disk as a Parquet file.

     pathName

       Path to save the file at.

     blockSize

       The size in bytes of blocks to write.

     pageSize

       The size in bytes of pages to write.

     compressCodec

       The compression codec to apply to pages.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used.

     Definition Classes
       AvroGenomicDataset

133. #### def saveAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

     Saves this genomic dataset to disk as a Parquet file.

     Saves this genomic dataset to disk as a Parquet file.

     pathName

       Path to save the file at.

     blockSize

       Size per block.

     pageSize

       Size per page.

     compressCodec

       Name of the compression codec to use.

     disableDictionaryEncoding

       Whether or not to disable bit-packing. Default is false.

     Definition Classes
       AvroGenomicDataset → GenomicDataset

134. #### def saveAsParquet(args: SaveArgs): Unit

     Saves a genomic dataset to Parquet.

     Saves a genomic dataset to Parquet.

     args

       The output format configuration to use when saving the data.

     Definition Classes
       GenomicDataset

135. #### def saveAsPartitionedParquet(pathName: String, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, partitionSize: Int = 1000000): Unit

     Saves this RDD to disk in range binned partitioned Parquet format.

     Saves this RDD to disk in range binned partitioned Parquet format.

     pathName

       The path to save the partitioned Parquet file to.

     compressCodec

       Name of the compression codec to use.

     partitionSize

       Size of partitions used when writing Parquet, in base pairs (bp). Defaults to 1,000,000 bp.

     Definition Classes
       GenomicDataset

136. #### def saveAsSam(filePath: String, asType: SAMFormat, asSingleFile: Boolean, isSorted: Boolean): Unit

     Saves this genomic dataset to disk as a SAM/BAM/CRAM file.

     Saves this genomic dataset to disk as a SAM/BAM/CRAM file.

     filePath

       Path to save the file at.

     asType

       The SAMFormat to save as. If left null, we will infer the format from the file extension.

     asSingleFile

       If true, saves output as a single file.

     isSorted

       If the output is sorted, this will modify the header.

137. #### def saveAsSam(filePath: String, asType: Option[SAMFormat], asSingleFile: Boolean, sortOrder: SortOrder, deferMerging: Boolean, disableFastConcat: Boolean): Unit

138. #### def saveAsSam(filePath: String, asType: Option[SAMFormat] = None, asSingleFile: Boolean = false, isSorted: Boolean = false, deferMerging: Boolean = false, disableFastConcat: Boolean = false): Unit

     Saves this genomic dataset of ADAM read data into the SAM/BAM format.

     Saves this genomic dataset of ADAM read data into the SAM/BAM format.

     filePath

       Path to save files to.

     asType

       Selects whether to save as SAM, BAM, or CRAM. The default value is None, which means the file type is inferred from the extension.

     asSingleFile

       If true, saves output as a single file.

     isSorted

       If the output is sorted, this will modify the header.

     deferMerging

       If true and asSingleFile is true, we will save the output shards as a headerless file, but we will not merge the shards.

     disableFastConcat

       If asSingleFile is true and deferMerging is false, disables the use of the parallel file merging engine.

139. #### def saveAsSamString(): String

     Converts a genomic dataset into the SAM spec string it represents.

     Converts a genomic dataset into the SAM spec string it represents.

     This method converts a genomic dataset of AlignmentRecords back to an RDD of SAMRecordWritables and a SAMFileHeader, and then maps this RDD into a string on the driver that represents this file in SAM.

     returns

       A string on the driver representing this genomic dataset of reads in SAM format.

140. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

     Saves Avro data to a Hadoop file system.

     Saves Avro data to a Hadoop file system.

     This method uses a SparkContext to identify our underlying file system, which we then save to.

     Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

     U

       The type of the specific record we are saving.

     pathName

       Path to save records to.

     sc

       SparkContext used for identifying underlying file system.

     schema

       Schema of records we are saving.

     avro

       Seq of records we are saving.

     Attributes
       protected
     Definition Classes
       GenomicDataset

141. #### def saveMetadata(pathName: String): Unit

     Called in saveAsParquet after saving genomic dataset to Parquet to save metadata.

     Called in saveAsParquet after saving genomic dataset to Parquet to save metadata.

     Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

     pathName

       The filepath to the file where we will save the Metadata.

     Attributes
       protected
     Definition Classes
       AvroReadGroupGenomicDataset → AvroGenomicDataset → GenomicDataset

142. #### def savePartitionMap(pathName: String): Unit

     Save the partition map to disk.

     Save the partition map to disk. This is done by adding the partition map to the schema.

     pathName

       The filepath where we will save the partition map.

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

143. #### def saveProcessingSteps(pathName: String): Unit

     Save the processing steps to disk.

     Save the processing steps to disk.

     pathName

       The path to save processing steps to.

     Attributes
       protected
     Definition Classes
       AvroReadGroupGenomicDataset

144. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

     Saves a genomic dataset of Avro data to Parquet.

     Saves a genomic dataset of Avro data to Parquet.

     pathName

       The path to save the file to.

     blockSize

       The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

     pageSize

       The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

     compressCodec

       The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

     optSchema

       The optional schema to set. Defaults to None.

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

145. #### def saveRddAsParquet(args: SaveArgs): Unit

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

146. #### def saveReadGroups(pathName: String): Unit

     Save the read groups to disk.

     Save the read groups to disk.

     pathName

       The path to save read groups to.

     Attributes
       protected
     Definition Classes
       AvroReadGroupGenomicDataset

147. #### def saveSequences(pathName: String): Unit

     Save the sequence dictionary to disk.

     Save the sequence dictionary to disk.

     pathName

       The path to save the sequence dictionary to.

     Attributes
       protected
     Definition Classes
       GenomicDataset

148. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

149. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], txTag: ClassTag[(AlignmentRecord, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Y)]): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

150. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

151. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, X), (AlignmentRecord, Y)]

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

152. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], tixTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

153. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X], tixTag: ClassTag[(AlignmentRecord, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(AlignmentRecord, Seq[Y])]): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

154. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

155. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(AlignmentRecord, Iterable[X]), (AlignmentRecord, Seq[Y])]

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

156. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[AlignmentRecord]): AlignmentRecordDataset

     Sorts our genome aligned data by reference positions, with references ordered by index.

     Sorts our genome aligned data by reference positions, with references ordered by index.

     partitions

       The number of partitions for the new genomic dataset.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

     See also

       sortLexicographically

157. #### def sort(): AlignmentRecordDataset

     Sorts our genome aligned data by reference positions, with references ordered by index.

     Sorts our genome aligned data by reference positions, with references ordered by index.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sortLexicographically

158. #### def sortByReadName(): AlignmentRecordDataset

     Sorts our alignments by read name.

     Sorts our alignments by read name.

     returns

       Returns a new genomic dataset containing sorted alignments.

159. #### def sortByReferencePosition(): AlignmentRecordDataset

     Sorts our alignments by reference position, with references ordered by name.

     Sorts our alignments by reference position, with references ordered by name.

     Sorts alignments by the location where the reads are aligned. Unaligned reads are put at the end and sorted by read name. References are ordered lexicographically.

     returns

       Returns a new genomic dataset containing sorted alignments.

     See also

       sortByReferencePositionAndIndex

160. #### def sortByReferencePositionAndIndex(): AlignmentRecordDataset

     Sorts our alignments by reference position, with references ordered by index.

     Sorts our alignments by reference position, with references ordered by index.

     Sorts alignments by the location where the reads are aligned. Unaligned reads are put at the end and sorted by read name. References are ordered by index that they are ordered in the SequenceDictionary.

     returns

       Returns a new genomic dataset containing sorted alignments.

     See also

       sortByReferencePosition

161. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[AlignmentRecord]): AlignmentRecordDataset

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     partitions

       The number of partitions for the new genomic dataset.

     storePartitionMap

       A Boolean flag to determine whether to store the partition bounds from the resulting genomic dataset.

     storageLevel

       The level at which to persist the resulting genomic dataset.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

     See also

       sort

162. #### def sortLexicographically(): AlignmentRecordDataset

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sort

163. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

164. #### def toCoverage(): CoverageDataset

     Converts this set of reads into a corresponding CoverageDataset.

     Converts this set of reads into a corresponding CoverageDataset.

     returns

       CoverageDataset containing mapped genomic dataset of Coverage.

165. #### def toDF(): DataFrame

     returns

       These data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset

166. #### def toFragments(): FragmentDataset

     Convert this set of reads into fragments.

     Convert this set of reads into fragments.

     returns

       Returns a FragmentDataset where all reads have been grouped together by the original sequence fragment they come from.

167. #### def toReads(): ReadDataset

     Convert this genomic dataset of alignment records to reads.

     Convert this genomic dataset of alignment records to reads.

     returns

       Return this genomic dataset of alignment records converted to a ReadDataset.

168. #### def toString(): String

     Definition Classes
       AvroReadGroupGenomicDataset → GenomicDataset → AnyRef → Any

169. #### def trace(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

170. #### def trace(msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

171. #### def trace(msg: ⇒ Any): Unit

     Attributes
       protected
     Definition Classes
       Logging

172. #### def transform(tFn: Function[JavaRDD[AlignmentRecord], JavaRDD[AlignmentRecord]]): AlignmentRecordDataset

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

173. #### def transform(tFn: (RDD[AlignmentRecord]) ⇒ RDD[AlignmentRecord]): AlignmentRecordDataset

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

174. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): AlignmentRecordDataset

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying DataFrame as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

175. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[AlignmentRecord]): AlignmentRecordDataset

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying data as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

176. #### def transformDataset(tFn: Function[Dataset[AlignmentRecord], Dataset[AlignmentRecord]]): AlignmentRecordDataset

     (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     tFn

       A function that transforms the underlying Dataset as a Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       AlignmentRecordDataset → GenomicDataset

177. #### def transformDataset(tFn: (Dataset[AlignmentRecord]) ⇒ Dataset[AlignmentRecord]): AlignmentRecordDataset

     (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     tFn

       A function that transforms the underlying Dataset as a Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       AlignmentRecordDataset → GenomicDataset

178. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[JavaRDD[AlignmentRecord], JavaRDD[X]], convFn: Function2[AlignmentRecordDataset, RDD[X], Z]): Z

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new genomid dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

179. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (RDD[AlignmentRecord]) ⇒ RDD[X])(implicit convFn: (AlignmentRecordDataset, RDD[X]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

180. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

181. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (DataFrame) ⇒ DataFrame)(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (AlignmentRecordDataset, Dataset[Y]) ⇒ Z): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

182. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[Dataset[AlignmentRecord], Dataset[Y]], convFn: GenomicDatasetConversion[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

183. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (Dataset[AlignmentRecord]) ⇒ Dataset[Y])(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (AlignmentRecordDataset, Dataset[Y]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

184. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[AlignmentRecord]

     Definition Classes
       AlignmentRecordDataset → GenomicDataset

185. #### def union(datasets: AlignmentRecordDataset*): AlignmentRecordDataset

     (Scala-specific) Unions together multiple genomic datasets.

     (Scala-specific) Unions together multiple genomic datasets.

     datasets

       Genomic datasets to union with this genomic dataset.

     Definition Classes
       AlignmentRecordDataset → GenomicDataset

186. #### def union(datasets: List[AlignmentRecordDataset]): AlignmentRecordDataset

     (Java-specific) Unions together multiple genomic datasets.

     (Java-specific) Unions together multiple genomic datasets.

     datasets

       Genomic datasets to union with this genomic dataset.

     Definition Classes
       GenomicDataset

187. #### def unpersist(): AlignmentRecordDataset

     Unpersists underlying RDD from memory or disk.

     Unpersists underlying RDD from memory or disk.

     returns

       Uncached GenomicDataset.

     Definition Classes
       GenomicDataset

188. #### val unproductFn: (AlignmentRecord) ⇒ AlignmentRecord

     Attributes
       protected
     Definition Classes
       AlignmentRecordDataset → GenomicDataset

189. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

190. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

191. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

192. #### def warn(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

193. #### def warn(msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

194. #### def warn(msg: ⇒ Any): Unit

     Attributes
       protected
     Definition Classes
       Logging

195. #### def writePartitionedParquetFlag(pathName: String, partitionSize: Int): Unit

     Save partition size into the partitioned Parquet flag file.

     Save partition size into the partitioned Parquet flag file.

     pathName

       Path to save the file at.

     partitionSize

       Partition bin size, in base pairs, used in Hive-style partitioning.

     Definition Classes
       AvroGenomicDataset → GenomicDataset

196. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicDataset

### Inherited from AvroReadGroupGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

### Inherited from GenomicDatasetWithLineage[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

### Inherited from AvroGenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

### Inherited from GenomicDataset[AlignmentRecord, AlignmentRecord, AlignmentRecordDataset]

### Inherited from Logging

### Inherited from AnyRef

### Inherited from Any

### Ungrouped